package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;



	//[Frame(factoryClass="Preloader")]
	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    

    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
   
    [Embed(source = "pig.png")] private static var embedPicPig:Class;

    public var dictPic:Dictionary = new Dictionary();
    public function getData(wname:String):BitmapData { return dictPic[wname]; }

    
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);
      
      dictPic["pig"] = (new embedPicPig).bitmapData;
      
      
      myDraw = new xVertDraw();
      myDraw.init(1024);
      
      camy = 80;
      
      vecObj = new Vector.<xObj>(0, false);

      var a:xObj;      var i:int;
      for (i = 0; i < 256; i += 1)
      {
        a = new xObj();
          a.cx = Math.random() * 8192 - 4096;
          a.cy = Math.random() * 8192 - 4096;
          a.cz = Math.random() * 8192 - 4096;          
          a.vx = Math.random() - 0.5;
          a.vy = Math.random() - 0.5;
          a.vz = Math.random() - 0.5;          
          a.vang = (Math.random() - 0.5) * 0.1;
          a.skin = getData("pig");
        vecObj.push(a);
      }//nexti
      
      
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init
   
    
    public var myDraw:xVertDraw;
    public var tpmat:Vector.<Number> = Vector.<Number>([1, 0, 0, 0, 0, 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 1]); 
    public var viewMat:Vector.<Number> = Vector.<Number>([1, 0, 0, 0, 0, 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 1]); 

    public var camz:Number = 400;
    public var camyaw:Number = 0;
    public var cori:xQuat = new xQuat();
  
    public var myAdvFont:xAdvFont;
    
    
    public var ori:xQuat = new xQuat();
    
    public var turnu:Number = 0;
    public var turns:Number = 0;

    public var vecObj:Vector.<xObj>;

    public function onEnter(e:Event):void
    {  
    
 
      mx = stage.mouseX; my = stage.mouseY;
      if (mx < 0) { mx = 0; } if (my < 0) { my = 0; }
      if (mx > 640) { mx = 640; } if (my > 480) { my = 480; }
      wmx = mx; wmy = my;
   

      graphics.clear();
      graphics.lineStyle(2, 0);

    
      var ts:Number;
      ts = 0.03;
      
       ms = 8;
       
      if (isKeyDown(Keyboard.UP)) { turnu += ts;  }
      if (isKeyDown(Keyboard.DOWN)) { turnu += -ts; }
      if (isKeyDown(Keyboard.LEFT)) {  turns += ts; }
      if (isKeyDown(Keyboard.RIGHT)) { turns += -ts; }
      
      turnu *= 0.85;
      turns *= 0.85;
      
      cori.rotPitch(turnu);
      cori.rotYaw(turns);
  
       
      if (isKeyDown(Keyboard.W)) { camx += cori.getFrontVx()*-ms;   camy += cori.getFrontVy()*-ms;  camz += cori.getFrontVz()*-ms;  }
      if (isKeyDown(Keyboard.S)) { camx += cori.getFrontVx()*ms;   camy += cori.getFrontVy()*ms;  camz += cori.getFrontVz()*ms;  }
      if (isKeyDown(Keyboard.A)) { camx += cori.getSideVx()*-ms;   camy += cori.getSideVy()*-ms;  camz += cori.getSideVz()*-ms;  }
      if (isKeyDown(Keyboard.D))  { camx += cori.getSideVx()*ms;   camy += cori.getSideVy()*ms;  camz += cori.getSideVz()*ms;  }

      
          
       num = vecObj.length;
        for (i = 0; i < num; i += 1)
        {
          a = vecObj[i];
           a.cx += a.vx;            a.cy += a.vy;            a.cz += a.vz;
           a.ang += a.vang;
        }//nexti
      
      
      
       xVertDraw.setProjMat(tpmat, 90, 640/480, 1, 16000);
       xVertDraw.setViewMat(viewMat, camx, camy, camz,  cori.x, cori.y, cori.z, cori.w);
       xVertDraw.multMatrix(tpmat, viewMat, myDraw.projMat);
       

      myDraw.it = 0;
      
      var a:xObj; var i:int; var num:int;
      num = vecObj.length;
      for (i = 0; i < num; i += 1)
      {
        a = vecObj[i];
        v = myDraw.addVert(a.cx, a.cy, a.cz, 32);
        v.roll = a.ang;
        v.skin = a.skin;
      }//nexti
      
      //myDraw.renderVert(graphics); 
      
      // canvas.fillRect(canvas.rect, 0x808080);
       canvas.fillRect(canvas.rect, 0);
   
          myDraw.sortVert(myDraw.vecVert, myDraw.it);
          var v:xVert; var vv:Vector.<xVert>;
          vv = myDraw.vecVert;
          num = myDraw.it;
          for (i = 0; i < num; i += 1)
          {
            v = vv[i];
            
            drawSprite2(canvas, v.skin, v.sx, v.sy, v.roll, false, false, v.sr/32, v.sr/32);
            
          }//nexti
          
        graphics.beginBitmapFill(canvas, null, false, false);
          graphics.drawRect(0, 0, 640, 480);
        graphics.endFill();
      canvas.unlock();
      canvas.lock();

       
     var w:Number;
       w = 10240;
     //  myDraw.drawBox(graphics, -w, -w, -w, w, w, w);

       
     
      graphics.lineStyle();
       myAdvFont.writeStrSpr(graphics, 16, 16, "WASD Thrust\nArrows Turn");
      
      var ms:Number;
      graphics.lineStyle(2, 0);
        ms = 8;
        graphics.moveTo(mx, my - ms);
        graphics.lineTo(mx, my + ms);
        graphics.moveTo(mx-ms, my);
        graphics.lineTo(mx+ms, my);


       gt += 1;
       keyTime += 1;
    }//onenter
    
    
    
    public var ident:Vector.<Number> = Vector.<Number>([1, 0, 0, 0, 0, 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 1]); 

    public var temp:Vector.<Number> = Vector.<Number>([1, 0, 0, 0, 0, 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 1]); 
    public var tq:xQuat = new xQuat();  

    
    
  
       
         
  }//classend
}

import flash.display.Graphics;
import flash.display.BitmapData;

internal class xObj
{
  public var ang:Number = 0;
  public var cx:Number = 0;  public var cy:Number = 0;  public var cz:Number = 0;
  public var vx:Number = 0;  public var vy:Number = 0;  public var vz:Number = 0;
  public var vang:Number = 0;
   
  public var skin:BitmapData = null;
  
}//xobj


internal class xQuat
{
 public var x:Number = 0;        public var y:Number = 0;    
 public var z:Number = 0;        public var w:Number = 1;
 
  public function reset():void {    x = 0;  y = 0;  z = 0;  w = 1;   }

  public function normalise():void
  { var mag:Number;  mag = (x * x) + (y * y) + (z * z) + (w * w);
    if (mag == 1.0) return; //already normal
    if (mag == 0) { x = 0;  y = 0;  z = 0;  w = 1; return; }
    mag = 1.0 / Math.sqrt(mag);  x *= mag; y *= mag; z *= mag; w *= mag;
  }//norm
  
  public function mul(a:xQuat):void
  {
    var tx:Number; var ty:Number; var tz:Number; var tw:Number;
    tx = (w * a.x + x * a.w + y * a.z - z * a.y);   ty = (w * a.y + y * a.w + z * a.x - x * a.z);
    tz = (w * a.z + z * a.w + x * a.y - y * a.x);   tw = (w * a.w - x * a.x - y * a.y - z * a.z);
    x = tx;   y = ty;  z = tz;    w = tw;
  }//mul

  public function rotAxis(ang:Number, xyz:int=0):void //0 x  1 y  2 z
  { var ax:Number; var ay:Number; var az:Number; var aw:Number;
    var tx:Number; var ty:Number; var tz:Number; var tw:Number;
    ang *= 0.5;
    ax = xyz == 0? Math.sin(ang):0;   ay  = xyz == 1? Math.sin(ang):0;  
    az = xyz == 2? Math.sin(ang):0; aw = Math.cos(ang);
    tx = (w * ax + x * aw + y * az - z * ay);   ty = (w * ay + y * aw + z * ax - x * az);
    tz = (w * az + z * aw + x * ay - y * ax);   tw = (w * aw - x * ax - y * ay - z * az);
    x = tx;  y = ty;     z = tz;   w = tw;     
    normalise();        
  }//rotaxis
  
  public function rotPitch(ang:Number):void { rotAxis(ang, 0); }
  public function rotYaw(ang:Number):void { rotAxis(ang, 1); }
  public function rotRoll(ang:Number):void { rotAxis(ang, 2); }
  public function rotAxisX(ang:Number):void { rotAxis(ang, 0); }
  public function rotAxisY(ang:Number):void { rotAxis(ang, 1); }
  public function rotAxisZ(ang:Number):void { rotAxis(ang, 2); }
        
 public function setVec(vec:Vector.<Number>):void
  { var xx:Number= x * x;  var xy:Number= x * y; var xz:Number = x * z;  var xw:Number = x * w;
    var yy:Number= y * y;  var yz:Number= y * z; var yw:Number = y * w;
    var zz:Number= z * z;  var zw:Number= z * w;
    vec[3]  = vec[7] = vec[11] = vec[12] = vec[13] = vec[14] = 0.0; vec[15] = 1.0;
    vec[0]  = 1.0 - 2.0 * ( yy + zz ); vec[4]  =     2.0 * ( xy - zw );   vec[8]  =     2.0 * ( xz + yw );
    vec[1]  =  2.0 * ( xy + zw ) ;     vec[5]  = 1.0 - 2.0 * ( xx + zz ); vec[9]  =  2.0 * ( yz - xw ) ;
    vec[2]  =     2.0 * ( xz - yw );   vec[6]  =     2.0 * ( yz + xw );   vec[10] = 1.0 - 2.0 * ( xx + yy );       
 }//setvec
   
  public function getSideVx():Number        { return 1.0 - 2.0 * ( y * y + z * z ); }        
  public function getSideVy():Number        { return 2.0 * ( x * y + z * w ); }    
  public function getSideVz():Number        { return  2.0 * ( x * z - y * w ); }
  public function getUpVx():Number        { return 2.0 * ( x*y - z*w ); }
  public function getUpVy():Number        { return 1.0 - 2.0 * ( x*x + z*z ); }    
  public function getUpVz():Number        { return 2.0 * ( y*z + x*w ); }
  public function getFrontVx():Number        {    return  2.0 * ( x*z + y*w ); }        
  public function getFrontVy():Number        {   return  2.0 * ( y*z - x*w );     }        
  public function getFrontVz():Number        {    return  1.0 - 2.0 * ( x*x + y*y );  }

 
}//xquat



internal class xVert
{
  public var sortCode:int = 0;

  public var sx:Number = 0;  public var sy:Number = 0;
  public var sr:Number = 0;
  public var sw:Number = 1;
  
  public var col:uint = 0x808080;
  public var skin:BitmapData = null;
  public var roll:Number = 0;

}//xvert


internal class xVertDraw 
{   
  public var projMat:Vector.<Number> = Vector.<Number>([1, 0, 0, 0, 0, 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 1]); 
  public var scrw:Number = 640;
  public var scrh:Number = 480;
  public var rendw:Number = 640 * 0.5;
  public var rendh:Number = 480 * 0.5;  
  public function xVertDraw()
  {    setProjMat(projMat, 90, 1, 1, 1000);  }//ctor  
  
  
  
   public function drawMesh3(g:Graphics, vf:Vector.<int>, vec:Vector.<Number>, mat:Vector.<Number>):void
    {
      var k:int; var i:int; var num:int;
      var rx:Number; var ry:Number; var rz:Number;
      var x0:Number; var y0:Number; var z0:Number;
      var x1:Number; var y1:Number; var z1:Number;
      var x2:Number; var y2:Number; var z2:Number;      
      num = vf.length;    
      for (k = 0; k < num; k += 3)
      {
        i = vf[k] * 3;  rx = vec[i]; ry = vec[i+1]; rz = vec[i+2];                
         x0 = rx * mat[0] + ry * mat[4] + rz * mat[8] +  mat[12];
         y0 = rx * mat[1] + ry * mat[5] + rz * mat[9] +  mat[13]; 
         z0 = rx * mat[2] + ry * mat[6] + rz * mat[10] + mat[14]; 

        i = vf[k+1]*3;  rx = vec[i]; ry = vec[i+1]; rz = vec[i+2];              
         x1 = rx * mat[0] + ry * mat[4] + rz * mat[8] +  mat[12];
         y1 = rx * mat[1] + ry * mat[5] + rz * mat[9] +  mat[13]; 
         z1 = rx * mat[2] + ry * mat[6] + rz * mat[10] + mat[14]; 

        i = vf[k+2]*3;  rx = vec[i]; ry = vec[i+1]; rz = vec[i+2];  
         x2 = rx * mat[0] + ry * mat[4] + rz * mat[8] +  mat[12];
         y2 = rx * mat[1] + ry * mat[5] + rz * mat[9] +  mat[13]; 
         z2 = rx * mat[2] + ry * mat[6] + rz * mat[10] + mat[14]; 

        //drawLine(g, x0, y0, z0, x1, y1, z1);
        //drawLine(g, x0, y0, z0, x2, y2, z2);
        //drawLine(g, x1, y1, z1, x2, y2, z2);
        
        drawTri(g, x0, y0, z0, x1, y1, z1,  x2, y2, z2, true);

      }//nextk
      
    }//drawmesh3
    
    
     public function drawTri(g:Graphics, x0:Number, y0:Number, z0:Number,
      x1:Number, y1:Number, z1:Number, x2:Number, y2:Number, z2:Number, cull:Boolean=false):void
      {
        var mat:Vector.<Number>;
        var sx0:Number, sy0:Number, w0:Number; 
        var sx1:Number, sy1:Number, w1:Number; 
        var sx2:Number, sy2:Number, w2:Number;     
        var wind:Number;
        mat = projMat;
        
        w0 = x0 * mat[3] + y0 * mat[7] + z0 * mat[11] + mat[15];
        w1 = x1 * mat[3] + y1 * mat[7] + z1 * mat[11] + mat[15];
        w2 = x2 * mat[3] + y2 * mat[7] + z2 * mat[11] + mat[15];    
        if (w0 <= 0 && w1 <= 0 && w2 <= 0) { return; }
      
        sx0 = x0 * mat[0] + y0 * mat[4] + z0 * mat[8] + mat[12];
        sy0 = x0 * mat[1] + y0 * mat[5] + z0 * mat[9] + mat[13];
        
        sx1 = x1 * mat[0] + y1 * mat[4] + z1 * mat[8] + mat[12];
        sy1 = x1 * mat[1] + y1 * mat[5] + z1 * mat[9] + mat[13];

        sx2 = x2 * mat[0] + y2 * mat[4] + z2 * mat[8] + mat[12];
        sy2 = x2 * mat[1] + y2 * mat[5] + z2 * mat[9] + mat[13];

         
        sx0 /= w0; sy0 /= w0; sx1 /= w1; sy1 /= w1;   sx2 /= w2; sy2 /= w2; 

        //hack -- cheap projection fix
        if (w0 < 0.0)
        { if (sx0 > 0) {  sx0 = -1.0 - sx0;  } else { sx0 = 1.0 - sx0; }
          if (sy0 > 0) {  sy0 = -1.0 - sy0; }  else { sy0 = 1.0 - sy0; }          
        }//endif  
        
        if (w1 < 0.0)
        { if (sx1 > 0) {  sx1 = -1.0 - sx1;  } else { sx1 = 1.0 - sx1; }
          if (sy1 > 0) {  sy1 = -1.0 - sy1; }  else { sy1 = 1.0 - sy1; }          
        }//endif     
         
        if (w2 < 0.0)
        { if (sx2 > 0) {  sx2 = -1.0 - sx2;  } else { sx2 = 1.0 - sx2; }
          if (sy2 > 0) {  sy2 = -1.0 - sy2; }  else { sy2 = 1.0 - sy2; }          
        }//endif  

        
        sx0 *= rendw;  sy0 *= -rendh;    sx0 += rendw;  sy0 += rendh;   
        sx1 *= rendw;  sy1 *= -rendh;    sx1 += rendw;  sy1 += rendh;
        sx2 *= rendw;  sy2 *= -rendh;    sx2 += rendw;  sy2 += rendh;
         
           
        //backface culling - check winding
        if (cull)
        { if (((sx1 - sx0) * (sy2 - sy0) - (sx2 - sx0) * (sy1 - sy0)) > 0) { return; } }
     
        g.moveTo(sx0, sy0);     g.lineTo(sx1, sy1);        
        g.lineTo(sx2, sy2);     g.lineTo(sx0, sy0);        
      }//drawtri
      

    public function drawBox3(g:Graphics, ax:Number, ay:Number, az:Number,
    rx:Number, ry:Number, rz:Number):void
    { drawBox(g, ax-rx, ay-ry, az-rz,   ax + rx, ay + ry, az + rz); }
  
    public function drawBox2(g:Graphics, ax:Number, ay:Number, az:Number,
    aw:Number, ah:Number, ad:Number):void
    { drawBox(g, ax, ay, az,   ax + aw, ay + ah, az + ad); }
  
    public function drawBox(g:Graphics, minx:Number, miny:Number, minz:Number,
      maxx:Number, maxy:Number, maxz:Number):void
        {
          //bottom
          drawLine2(g, minx, miny, minz,   maxx, miny, minz);
          drawLine2(g, minx, miny, maxz,   maxx, miny, maxz);
          drawLine2(g, minx, miny, minz,   minx, miny, maxz);
          drawLine2(g, maxx, miny, minz,   maxx, miny, maxz);  
          
          //top
          drawLine2(g,minx, maxy, minz,   maxx, maxy, minz);
          drawLine2(g,minx, maxy, maxz,   maxx, maxy, maxz);
          drawLine2(g,minx, maxy, minz,   minx, maxy, maxz);
          drawLine2(g, maxx, maxy, minz,   maxx, maxy, maxz);
           
          //bot
          drawLine2(g,minx, miny, minz,   minx, maxy, minz);
          drawLine2(g,maxx, miny, minz,   maxx, maxy, minz);
          drawLine2(g,minx, miny, maxz,   minx, maxy, maxz);
          drawLine2(g,maxx, miny, maxz,   maxx, maxy, maxz);
  
        }//drawbox
        
        
  //cheat -- instead of screwing around with proper frustum clipping:
   //draw multiple little lines (and call it a day)
  public function drawLine2(g:Graphics, ax:Number, ay:Number, az:Number,
  bx:Number, by:Number, bz:Number):void
  {  
    var mat:Vector.<Number>;  var w0:Number, w1:Number;
    mat = projMat;
    w0 = ax * mat[3] + ay * mat[7] + az * mat[11] + mat[15];
    w1 = bx * mat[3] + by * mat[7] + bz * mat[11] + mat[15];
    if (w0 <= 0 && w1 <= 0) { return; }
    if (w0 > 0 && w1 > 0) { drawLine(g, ax, ay, az, bx, by, bz); return; }
    
    var u:Number; var t:Number;
    var kx:Number; var ky:Number; var kz:Number;
    kx = (bx - ax); ky = (by - ay); kz = (bz - az);
    t = 0.2;
    for (u = 0; u < 1; u += t)
    {  drawLine(g, ax + kx * u, ay + ky * u, az + kz * u,
       ax + kx * (u + t), ay + ky * (u + t), az + kz * (u + t));  }
  }//dline2
    
        
  //just check z? 
  //http://users.tpg.com.au/wagnerbe/qbasic/3d.txt
  
  public function drawLine(g:Graphics, ax:Number, ay:Number, az:Number,
  bx:Number, by:Number, bz:Number):void
  {
    var mat:Vector.<Number>;
    var sx0:Number, sy0:Number, sz0:Number, w0:Number; 
    var sx1:Number, sy1:Number, sz1:Number, w1:Number; 
     mat = projMat;
    

    w0 = ax * mat[3] + ay * mat[7] + az * mat[11] + mat[15];
    w1 = bx * mat[3] + by * mat[7] + bz * mat[11] + mat[15];
    if (w0 <= 0 && w1 <= 0) { return; }

    sx0 = ax * mat[0] + ay * mat[4] + az * mat[8] + mat[12];
    sy0 = ax * mat[1] + ay * mat[5] + az * mat[9] + mat[13];
    //sz0 = ax * mat[2] + ay * mat[6] + az * mat[10] + mat[14];

    sx1 = bx * mat[0] + by * mat[4] + bz * mat[8] + mat[12];
    sy1 = bx * mat[1] + by * mat[5] + bz * mat[9] + mat[13];
    //sz1 = bx * mat[2] + by * mat[6] + bz * mat[10] + mat[14];
 
    sx0 /= w0; sy0 /= w0;

    //projection fix
    if (w0 < 0.0)
    { if (sx0 > 0) {  sx0 = -1.0 - sx0;  } else { sx0 = 1.0 - sx0; }
      if (sy0 > 0) {  sy0 = -1.0 - sy0; }  else { sy0 = 1.0 - sy0; }          
    }//endif  
    sx0 *= rendw;  sy0 *= -rendh;    sx0 += rendw;  sy0 += rendh;
    
    sx1 /= w1; sy1 /= w1;
    //projection fix
    if (w1 < 0.0)
    { if (sx1 > 0) {  sx1 = -1.0 - sx1;  } else { sx1 = 1.0 - sx1; }
      if (sy1 > 0) {  sy1 = -1.0 - sy1; }  else { sy1 = 1.0 - sy1; }          
    }//endif  
    sx1 *= rendw;  sy1 *= -rendh;    sx1 += rendw;  sy1 += rendh;    
    
    //my pathetic attempt at optimisation
    if (sx0 < 0 && sx1 < 0) { return; }    if (sy0 < 0 && sy1 < 0) { return; }
    if (sx0 > scrw && sx1 > scrw) { return; }  if (sy0 > scrh && sy1 > scrh) { return; }

    g.moveTo(sx0, sy0);    g.lineTo(sx1, sy1);        
  }//drawline  

    public static function setProjMat(vec:Vector.<Number>,
     fovdeg:Number = 60.0, aspect:Number=1.0, nearp:Number = 1.0, farp:Number=1000.0):void
    {   var f:Number;   var i:int;
        for (i = 0; i < 16; i++) { vec[i] = 0.0;  } 
        f = 1.0 / Math.tan( (fovdeg * (3.1415 / 180.0)) * 0.5 );
        if (nearp == 0) { nearp = 0.0001; }
        if (farp == 0) { farp = 0.0001; }
        vec[0] = f / aspect;          vec[5] = f;
        vec[10] = (farp + nearp) / (nearp - farp);
        vec[14] = (2.0 * farp * nearp) / (nearp - farp);
        vec[11] = -1.0;          vec[15] = 0.0;
    }//projmatrix
    
    public static function setViewMat(vec:Vector.<Number>, 
        cx:Number, cy:Number, cz:Number,  qx:Number, qy:Number, qz:Number, qw:Number):void
        { var forwx:Number; var forwy:Number; var forwz:Number;
          var sidex:Number; var sidey:Number; var sidez:Number;
          var upx:Number;   var upy:Number;   var upz:Number;     
          var i:int; for(i=0;i<16;i++){vec[i]=0.0;}vec[0]=vec[5]=vec[10]=vec[15]=1.0;
          forwx=2.0*(qx*qz+qy*qw);forwy=2.0*(qy*qz-qx*qw);forwz=1.0-2.0*(qx*qx+qy*qy);
          upx=2.0*(qx*qy-qz*qw);upy=1.0-2.0*(qx*qx+qz*qz);upz=2.0*(qy*qz+qx*qw);
          sidex=1.0-2.0*(qy*qy+qz*qz);sidey=2.0*(qx*qy+qz*qw);sidez=2.0*(qx*qz-qy*qw);
          vec[0]=sidex;vec[4]=sidey;vec[8]=sidez;
          vec[1]=upx;vec[5]=upy;vec[9]=upz;
          vec[2]=forwx;vec[6]=forwy;vec[10]=forwz;
          vec[12]=(sidex*-cx)+(sidey*-cy)+(sidez*-cz);
          vec[13]=(upx*-cx)+(upy*-cy)+(upz*-cz);
          vec[14]=(forwx*-cx)+(forwy*-cy)+(forwz*-cz);
        }//setlookat

        //only works of 4x4 matrices
        public static function multMatrix(a:Vector.<Number>, b:Vector.<Number>, r:Vector.<Number>):void
        {   var i:int;  for (i = 0; i < 16; i += 4)
            {
                r[i] =     a[0] * b[i] + a[4] * b[i + 1] + a[8] * b[i + 2] + a[12] * b[i + 3];
                r[i + 1] = a[1] * b[i] + a[5] * b[i + 1] + a[9] * b[i + 2] + a[13] * b[i + 3];
                r[i + 2] = a[2] * b[i] + a[6] * b[i + 1] + a[10] * b[i + 2] + a[14] * b[i + 3];
                r[i + 3] = a[3] * b[i] + a[7] * b[i + 1] + a[11] * b[i + 2] + a[15] * b[i + 3];
            }//nexti
        }//multmat  
    
        
        
        
      public var vecVert:Vector.<xVert>;
      public var it:int = 0;
      public function init(num:int):void
      {
        vecVert = new Vector.<xVert>(num, false);
        var i:int;   for (i = 0; i < num; i++) { vecVert[i] = new xVert(); }
      }//init 
              
      public function renderVert(g:Graphics):void
      {
        //g.lineStyle(2, 0);
        var i:int; var num:int; var a:xVert;
        num = it;    sortVert(vecVert, num);
        for (i = 0; i < num; i++)
        { a = vecVert[i];
          g.beginFill(a.col, 1);
            g.drawCircle(a.sx, a.sy, a.sr);
          g.endFill();
        }//nexti 
        it = 0;
      }//rendervert
        
      public var emptyVert:xVert = new xVert();
      public function addVert(ax:Number, ay:Number, az:Number, rad:Number):xVert
      {
        var a:xVert;  var mat:Vector.<Number>;    var m:Number;
        var sx:Number;        var sy:Number;      var sz:Number;
        var w:Number; 
          mat = projMat;
         
          w = ax * mat[3] + ay * mat[7] + az * mat[11] + mat[15];
          if (w <= 0) { return emptyVert; }
          
          sx = ax * mat[0] + ay * mat[4] + az * mat[8] + mat[12];
          sy = ax * mat[1] + ay * mat[5] + az * mat[9] + mat[13];
          sz = ax * mat[2] + ay * mat[6] + az * mat[10] + mat[14];
         
          sx /= w; sy /= w;
          sx *= rendw;            sy *= -rendh;
          sx += rendw;            sy += rendh;
              
          m = (1 / w) * rendh * rad; 
              
          a = vecVert[it]; it += 1; if (it >= vecVert.length) { it = vecVert.length - 1; }
          a.sx = sx;   a.sy = sy;   a.sw = w;    a.sr = m;
          a.sortCode = 0x0FffFFff - int(sz);  
        
        return a;
      }//addvert
         
            
    public function sortVert(vec:Vector.<xVert>, num:int):void
    {  radixSortVert(vec, num);    }
     
    public var tempVec:Vector.<xVert> = new Vector.<xVert>(8192, false);
    public var tempBuck:Vector.<int> = new Vector.<int>(256, false);
    public function radixSortVert(vec:Vector.<xVert>, num:int):void
    {
      var a:xVert;          var temp:Vector.<xVert>;          var buck:Vector.<int>;
      var i:int;          var k:uint;          var shift:int;          var g:int;
      if (vec.length < num) { num = vec.length; }
      temp = tempVec;    if (temp.length < num) { return; }
      buck = tempBuck;    shift = 0;       
      while (shift < 32)  {   
        for (k = 0; k < 256; k++) { buck[k] = 0; }      //reset bucket
        for (i = 0; i < num; i++)  {  g = (vec[i].sortCode >> shift) &0xFF;  buck[g]++; }              
        for (i = 1; i < 256; i++)   {  buck[i] += buck[i - 1];  }               
        for (i = num - 1; i >= 0; i--)  { g = (vec[i].sortCode >> shift) &0xFF;  temp[--buck[g] ] = vec[i];  }        
        for (i = 0; i < num; i++) { vec[i] = temp[i];   }
        shift += 8; 
      }//wend
    }//radixsort   

}//vertdraw
